//---------------------------------------------------------------------------
// vcmame.h
//
// Header file used to compile M.A.M.E. with Visual C++
//---------------------------------------------------------------------------

#ifndef __VCMAME_H_
#define __VCMAME_H_
#pragma once

//---------------------------------------------------------------------------
// NOTE:
//
// All of the global #defines and library declarations have been moved into
// the project itself.  Although harder to maintain, it requires many less
// modifications to the M.A.M.E. source code that way
//---------------------------------------------------------------------------

// The IDE project manager can't seem to handle "INLINE=static __inline" as
// part of the project settings without screwing up, so the project declares
// "INLINE=__inline", and we overwrite it here with the proper expansion

#ifdef INLINE
#undef INLINE
#endif

#define INLINE static __inline

#include "windows\winprefix.h"		// <-- PI and M_PI

//---------------------------------------------------------------------------
// Compiler Warnings

#pragma warning(disable:4018)		// "signed/unsigned mismatch"
#pragma warning(disable:4022)		// "pointer mismatch for actual parameter"
#pragma warning(disable:4090)		// "different 'const' qualifiers"
#pragma warning(disable:4142)		// "benign redefinition of type"
#pragma warning(disable:4146)		// "unary minus operator applied to unsigned type"
#pragma warning(disable:4244)		// "possible loss of data"
#pragma warning(disable:4305)		// "truncation from 'type' to 'type'
#pragma warning(disable:4761)		// "integral size mismatch in argument"

//---------------------------------------------------------------------------
// M68000 Core Selection
//
// NOTE : If you change anything in this section, you must "Rebuild All"

#define A68K0						// Assembler-based M68000 CPU Core
//#define A68K2						// Assembler-based M68020 CPU Core

//---------------------------------------------------------------------------
// HAS_CPU Declarations
//
// NOTE : If you change anything in this section, you must "Rebuild All"

#define HAS_Z80 1
#define HAS_M6502 1
#define HAS_M6800 1
#define HAS_M6801 1
#define HAS_M6802 1
#define HAS_M6803 1
#define HAS_M6808 1
#define HAS_HD63701 1
#define HAS_M6805 1
#define HAS_M68705 1
#define HAS_HD63705 1
//#define HAS_HD6309 1
#define HAS_M6809 1
#define HAS_M68000 1
#define HAS_M68EC020 1
#define HAS_S2650 1
#define HAS_CCPU 1
//---------------------------------------------------------------------------
// HAS_SOUND Declarations
//
// NOTE : If you change anything in this section, you must "Rebuild All"

#define HAS_CUSTOM 1
#define HAS_SAMPLES 1
#define HAS_DAC 1
#define HAS_AY8910 1
#define HAS_YM2151_ALT 1
#define HAS_SN76496 1
#define HAS_ASTROCADE 1
#define HAS_NAMCO 1
#define HAS_K007232 1

//---------------------------------------------------------------------------

#endif		// __VCMAME_H_
